local ULTRAXION_SPELL_ID_LFR    = 109415
local ULTRAXION_SPELL_ID_NORMAL = 106371
local ULTRAXION_SPELL_ID_HC     = 109416

local function ReplaceIcons(message)
	local term
	for tag in string.gmatch(message, "%b{}") do
		term = strlower(string.gsub(tag, "[{}]", ""));
		if ( ICON_TAG_LIST[term] and ICON_LIST[ICON_TAG_LIST[term]] ) then
			message = string.gsub(message, tag, ICON_LIST[ICON_TAG_LIST[term]] .. "0|t");
		end
	end
	return message
end

local function InCombat()
  return UnitAffectingCombat("player");
end

local addonName, addon = ...
LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceEvent-3.0", "AceTimer-3.0")

function addon:OnInitialize()
	self:SetupDB()
	self:SetupOptions()
	self:SetEnabledState(self.db.global.enabled)
	self.current_ultraxion = 0	
end

function addon:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_START")
end

function addon:UNIT_SPELLCAST_START(event, unitID, spell, rank, lineID, spellID)
  if unitID ~= "boss1" then return end
  local mode  
  if spellID == ULTRAXION_SPELL_ID_HC then
    mode = "heroic"
  elseif spellID == ULTRAXION_SPELL_ID_NORMAL then
    mode = "normal"  
  else
    return
  end  
  
  self.whoStays = "{rt8}" .. self:NextOnes() .. "{rt8}"
  self:GoNextPair(mode)
	self:OutputWarning()
	self:ScheduleTimer("Timer", 20)	
end

function addon:Timer()
  if InCombat() then
    self.whoStays = "{rt1}" .. "Next one" .. ": " .. self:NextOnes() .. "{rt1}"
    self:OutputWarning()
  else
    self.current_ultraxion = 0
  end
end

function addon:GoNextPair(mode)
	if mode == "heroic" then	  	  
	  self.current_ultraxion = ((self.current_ultraxion + 1) % 3)
	else
	  self.current_ultraxion = ((self.current_ultraxion + 1) % 2)
	end
end

function addon:NextOnes()
  return self.db.global.priorities[tostring(self.current_ultraxion+1)]
end
		
function addon:OutputWarning()
	local announceSettings = self.db.global.announces
	if announceSettings.yell then
		SendChatMessage(self.whoStays, "YELL")
	end
	if announceSettings.raid then
		SendChatMessage(self.whoStays, "RAID")
	end
	if announceSettings.raidWarning then
		if IsRaidLeader("player") or IsRaidOfficer("player") then
			SendChatMessage(self.whoStays, "RAID_WARNING")
		end
	end
	if announceSettings.privateRaidWarning then
		RaidNotice_AddMessage(RaidWarningFrame, ReplaceIcons(self.whoStays), ChatTypeInfo["RAID_WARNING"])
		PlaySoundFile("Sound\\Interface\\RaidWarning.wav")
	end
	if announceSettings.privateChatMessage then
		print(ReplaceIcons(self.whoStays))
	end
end